// 选择器，值选择器
import React, { useState, useMemo, useEffect } from 'react'
import { Select, Checkbox, Radio } from 'antd'
import styels from './index.less'
import { GetSelectItemList } from '../../../../apis/process'

const { Option } = Select

const ComboBox = ({ value, onChange, schema }) => {

  const { placeholder, disabled, soruceType, options, dictionary, presetValue, showType, isMultiple, isEdit } = schema

  console.log('schema', schema)

  const [dictionaryList, setDictionaryList] = useState()

  const valueShow = useMemo(() => {
    if (isMultiple) {
      return (value || presetValue) ? (value || presetValue).split(',') : []
    } else {
      return value || presetValue || null
    }
  }, [presetValue, value])

  const enums = useMemo(() => {
    switch (soruceType) {
      case '手动输入':
        return Array.isArray(options) ? options.map(v => v.value) : []
      case '数据字典':
        return Array.isArray(dictionaryList) ? dictionaryList.map(v => v.nodeName) : []
      default:
        return []
    }
  }, [soruceType, options, dictionaryList])

  const handleChange = value => {
    if (isEdit) {

    } else {
      if (isMultiple) {
        onChange(value.join(','))
      } else {
        onChange(value)
      }
    }
  }

  const onFocus = async () => {
    const { data } = await GetSelectItemList({ nodeName: dictionary })
    if (Array.isArray(data)) {
      setDictionaryList(data)
    }
  }

  if (showType === '下拉') {
    return (
      <Select
        onFocus={onFocus}
        style={{ width: '100%' }}
        mode={isMultiple ? 'multiple' : ''}
        disabled={disabled}
        showArrow={!disabled}
        value={valueShow}
        placeholder={placeholder}
        onChange={handleChange}
      >
        {enums.map(v => <Option value={v} key={v}>{v}</Option>)}
      </Select>
    )
  }

  if (showType === '平铺') {
    return (
      <div className={styels.tileSelect} type={disabled ? 'disabled' : ''}>
        {
          isMultiple ?
            <Checkbox.Group
              disabled={disabled}
              onChange={value => onChange(value.join(','))}
              value={valueShow}
            >
              {enums.map(v => <Checkbox key={v} value={v}>{v}</Checkbox>)}
            </Checkbox.Group>
            :
            <Radio.Group onChange={e => onChange(e.target.value)} value={valueShow} disabled={disabled}>
              {enums.map(v => <Radio key={v} value={v}>{v}</Radio>)}
            </Radio.Group>
        }
      </div>
    )
  }

  return null

}

export default ComboBox
